#include <sta/config.hpp>

#ifdef STA_STARTUP_TASK_ENABLE

#include <sta/lang.hpp>
#include <sta/system_event.hpp>
#include <sta/watchdog.hpp>

#include <main.h>

#include <cmsis_os2.h>


namespace sta
{
	// Weak noop to be overridden by application if required
	STA_WEAK void startupTaskExtras(void *) {}
} // namespace sta


// Declare with C linkage
extern "C"
{
	void startupTask(void * arg)
	{
		// Call further initialization code
		sta::startupTaskExtras(arg);


#ifdef STA_WATCHDOG_ENABLE
		// Start timers
		sta::startWatchdogTimer();
#endif

		// Wake tasks
		sta::signalStartupEvent();

		// Terminate task
		osThreadExit();
	}
}


#endif // STA_STARTUP_TASK_ENABLE
