#include <sta/watchdog.hpp>

#ifdef STA_WATCHDOG_ENABLE

#include <cmsis_os2.h>


#ifndef STA_WATCHDOG_TIMER_PERIOD
#  define STA_WATCHDOG_TIMER_PERIOD 1000
#endif // STA_WATCHDOG_TIMER_PERIOD


// Access handles from freertos.c
extern osTimerId_t heartbeatHandle;


namespace sta
{
	void startWatchdogTimer()
	{
		osTimerStart(heartbeatHandle, STA_WATCHDOG_TIMER_PERIOD);
	}
} // namespace sta


// Declare with C linkage
extern "C"
{
	void heartbeatCallback(void *)
	{
		// Notify watchdog task to send heartbeat message
		// Required because blocking in a timer callback is not allowed
		sta::notifyWatchdog(STA_WATCHDOG_FLAG_HEARTBEAT);
	}
}


#endif // STA_WATCHDOG_ENABLE
