#include <sta/watchdog.hpp>

#ifdef STA_WATCHDOG_ENABLE

#include <sta/lang.hpp>
#include <sta/os2.hpp>
#include <sta/system_event.hpp>

#include <main.h>

#include <cmsis_os2.h>


// Access handles from freertos.c
extern osThreadId_t watchdogHandle;


namespace sta
{
	void notifyWatchdog(uint32_t flags)
	{
		osThreadFlagsSet(watchdogHandle, flags);
	}


	// Handler for watchdog events
	extern void watchdogEventHandler(void * arg, uint32_t flags);
} // namespace sta


// Declare with C linkage
extern "C"
{
	STA_WEAK void watchdogTask(void * arg)
	{
		sta::waitForStartupEvent();

		while (true)
		{
			// Wait for any flag to be set
			uint32_t flags = osThreadFlagsWait(STA_OS2_THREAD_FLAGS_VALID_BITS, osFlagsWaitAny, osWaitForever);

			// Call event handler
			sta::watchdogEventHandler(arg, flags);
		}
	}
}


#endif // STA_WATCHDOG_ENABLE
